$(document).ready(function () {
    $("body").off("click").on("click", ".remove", remove);
    $(".tbody").on("keyup change blur focus", ".qty", calDetail);
    $("body").on("blur ", ".qty", autoadd);
    $("body").on("blur", ".itemname", chNew);
    $("body").on("change", ".itemcode", getitem);

    $(".itemgrp").hide();

    function getitem() {
        var tr = $(this).closest("tr");

        var itemcode = tr.find(".itemcode").val();
        var vouchdt = $(".vouchdt").val();

        if (itemcode > 0) {
            $.ajax({
                type: "POST",
                datatype: "json",
                url: "search_onl_ibarcode.php",
                data: {barcode: itemcode, vouchdt: vouchdt},
                success: function (response) {
                    var m = response;

                    tr.find(".barcode").val(m.barcode);
                    tr.find(".unit").val(m.unit);
                    tr.find(".type").val(m.type);
                    tr.find(".batch").val(m.batch);
                    tr.find(".origin").val(m.origin);
                    tr.find(".bbfmon").val(m.bbfmon);
                    tr.find(".bbfyear").val(m.bbfyear);
                    tr.find(".qty").focus();
                    tr.find(".qty").select();

                },
                error: function (request, textStatus, errorThrown) {

                }
            });
        }
    }


    function chNew() {
        var tr = $(this).closest("tr"),
                itemname = tr.find(".itemname").val(),
                barcode = tr.find(".barcode").val();
        if (itemname != "" && barcode == "") {
            tr.find(".barcode").val("New");
        }
    }

    $("form").submit(function () {
        // var party = $(".cmbparty").val(),
        //         totbillamt = $(".totbillamt").val(),
        //         valid = true;
        
        var canSubmit = true;
    
            $(".tbody").find('tr').each(function () {
                var tr = $(this),
                    qty = tr.find(".qty").val(),
                    bbfmon = tr.find(".bbfmon").val(),
                    bbfyear = tr.find(".bbfyear").val();
                

                    if (qty <= 0){
                        alert("Qty Cannot Be Empty Or Zero.");
                        canSubmit = false;
                        tr.find(".qty").focus();
                    }

                    // if (bbfmon <= 0){
                    //     alert("Best Before Month Cannot Be Empty Or Zero.");
                    //     canSubmit = false;
                    //     tr.find(".bbfmon").focus();
                    // }
                   
                    // if (bbfyear <= 0){
                    //     alert("Best Before Year Cannot Be Empty Or Zero.");
                    //     canSubmit = false;
                    //     tr.find(".bbfyear").focus();
                    // }
                       
            });


        // if (valid) {
        //     var isValid = true;

        //     if (isValid) {
        //         $("#submit").hide();
        //         $("#cancel").hide();
        //     }
        // }

        return canSubmit; // Return false if canSubmit is set to false, preventing form submission        

    });


    function autoadd() {
        if ($(this).closest("tr").is(":last-child")) {
            AddRows();
        }
    }

    $(".invno").blur(function () {
        $(".party").select2("open");
    });

    function calDetail() {
        var ttotqty = 0;
        $(".qty").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                ttotqty += parseFloat(this.value);
            }
        });
        $(".ttotqty").val(ttotqty);
    }



    $("#addnew").click(function () {
        AddRows();
        //        caltran();
    });
    function remove() {
        $(this).closest("tr").remove();
        //        caltran();
    }

    function AddRows() {
        var ctr = $("#items").val();
        var prodtype = $(".prodtype").val();
        var rd = $(".rd").val();
        var frmname = $(".frmname").val();
        var godown = $(".godown").val();
        var hide_check = "";
        if ($("#del_all").prop("checked")) {
            hide_check = 0;
        } else {
            hide_check = 1;
        }
        var detail = ".fetchpart_" + ctr;
        var focusFld = ".focusFld_" + ctr;
        ctr++;
        $("#items").val(ctr);
        $.post("onlent_demo_add.php", {ctr: ctr, hide: hide_check, prodtype: prodtype, rd: rd, frmname: frmname, godown: godown},
                function (data) {
                    $(data).appendTo(".tbody");
                    $(detail).select2();
//                $(focusFld).focus();
//                getLoc();
                }
        );
    }
});
